<?php defined('SYSPATH') or die('No direct script access.');

class Model_Students extends Model
{
    public static function ofDiscipline($id, $semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;;
        $sql = "CALL `GetStudentsForDiscipline`('$id', $semesterID); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /**
     * @param $group int group id
     * @return Database_Result
     */
    public static function ofGroup($group, $semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;;
        $sql = "CALL `GetStudents`('$group', $semesterID); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function getGradeID($gradeNum, $degree) {
        $degree = Database::instance()->escape($degree);
        $sql = "SELECT `GetGradeID`('$gradeNum', $degree) AS `ID`; ";
        return DB::query(Database::SELECT, $sql)->execute()->get('ID');
    }

    public static function byStudyGroup($groupID) {
        return self::collect(self::ofGroup($groupID));
    }

    public static function byFaculty($facultyID, $gradeID, $groupID, $semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;;
        $sql = "CALL `GetStudentsByFaculty`('$facultyID', '$gradeID', $groupID, $semesterID); ";
        $students = DB::query(Database::SELECT, $sql)->execute();
        return self::collect($students);
    }

    public static function searchStudents($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID, $semesterID = null) {
        $Name = Database::instance()->escape($Name);
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;
        $sql = "CALL `SearchStudents`('$GradeID', '$GroupID', '$FacultyID', $Name, '$DisciplineID', $semesterID); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    private static function collect($students) {
        $studentsHandled = array();
        foreach($students as $row) {
            $row['Degree'] = Model_Grades::getDegreeTitle($row['Degree']);
            $studentsHandled[] = $row;
        }
        return $studentsHandled;
    }

    public static function NotAttendingDiscipline($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID) {
        $students = self::searchStudents($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID);
        return self::collect($students);
    }

    /*
     * TODO:
     *      a wrapper around `view_students` table
     *      see GetStudents, SearchStudents procedures.
     */
}